---
title: "The Pants community"
slug: "the-pants-community"
hidden: false
createdAt: "2021-03-13T18:57:07.437Z"
updatedAt: "2021-11-06T00:28:12.217Z"
---
Who is behind Pants?
--------------------

Pants is developed by a community of people who are passionate about improving the craft of software engineering.  We come from diverse backgrounds and interests, but share the goal of creating the best tools to support more effective and enjoyable software development.

 Pants Build is registered as a 501c(6) non-profit in California, whose purpose is to maintain the Pants project's assets, such as its CI resources.

Can I join this community?
--------------------------

Absolutely! We welcome the involvement of anyone who shares our passion for creating state-of-the-art software development tooling.

Joining the Pants community can be as simple as jumping into one of our [Slack channels](doc:getting-help) for a chat. We welcome questions, comments, opinions, jokes and memes on anything related to software development tooling and practices. We'd love to hear about your current or planned uses of Pants, and, of course, we are happy to help onboard you and your team!

There are no bad questions. We require only that all community members abide by our [Code of Conduct](doc:code-of-conduct).

How can I contribute to Pants?
------------------------------

Contributions come in many forms, and we appreciate all of them! Examples include reporting or fixing bugs, suggesting or adding new features, improving documentation, identifying confusing or insufficient error messages, answering user questions on Slack, helping with developer outreach, and more. 

Whatever your area of expertise and your skill level, there may be valuable contributions you can make.  Are you a graphic designer? A technical writer? Do you know how to make videos? There might be a cool contribution in your future.

We try and make contributions easy. For example, you can suggest documentation fixes by clicking on the Suggest Edits link on any page. And you can report bugs by opening a [GitHub issue](https://github.com/pantsbuild/pants/issues). If you want to hack on the Pants codebase itself there is a [helpful guide](doc:contributor-overview).

For some contributions, such as adding new features, the best place to get started is our [Slack workspace](doc:getting-started). You can make suggestions, solicit feedback and connect with like-minded contributors. That way we know who is working on what, and can help you avoid duplicating efforts or hitting known pitfalls.

If you want to contribute but don't have a specific plan or idea, we can help you discover some fruitful areas to focus on. There is plenty to do!

How is the community structured?
--------------------------------

We welcome contributions from anyone, and we recognize consistent contribution with special statuses.

### Maintainers

Pants has a core group of [_Maintainers_](doc:maintainers): trusted people with a long-term interest in Pants who have made regular contributions for some time and plan to continue to do so. Maintainers conduct code reviews of pull requests, and may be granted extra permissions, such as write access to the Pants repository, as needed. 

### Contributors

Anyone who has made a few contributions of any kind, and has an ongoing interest in the Pants project, may be nominated by a Maintainer to become a _Contributor_. 

Contributors may be granted extra permissions, such as the ability to assign issues, but these stop short of full Maintainer permissions. Contributors do not have any new obligations—for example, you are _not_ expected to make a certain number of changes. However, contributors are expected to respect their extra permissions. Contributors will be eligible to receive more attention and mentorship in activities like code review. Contributors with a continuing track record of contribution may be nominated to become Maintainers.

### Maintainers Emeritus

Sometimes a Maintainer may need to step back to less intensive involvement. To recognize their past contributions, they retain the honorary _Emeritus_ status.

### Officers

This is a subset of the Maintainers that are officers of the Pants Build 501c(6) organization. Their role is primarily bureaucratic, as well as a formality required by the State of California. They don't have extra voting power over the other Maintainers.

How are decisions made?
-----------------------

We strive to arrive at decisions - about priorities, technical choices and others - by consensus where possible. If we cannot achieve consensus, we have [a process in place](doc:contentious-decisions) for putting decisions to a vote among the Maintainers. We avail ourselves of this process extremely rarely.
